/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package animation;

import java.awt.*;
import java.awt.geom.*;

/**
   An Mars icon that can be moved around
*/
public class MarsShape implements MoveableShape
{
   /**
      Constructs a Mars icon of a given size.
      @param x the left of the bounding rectangle
      @param y the top of the bounding rectangle
      @param size the size of the icon
   */
   public MarsShape(int x, int y, int size)
   {
       this.x = x;
       this.y = y;
       this.size = size;
   }

   public void translate(int dx, int dy)
   {
      x += dx;
      y += dy;
   }

   public void draw(Graphics2D g2)
   {
      Ellipse2D.Double planet = new Ellipse2D.Double(x, y,
            size, size);
      g2.setColor(Color.RED);
      g2.fill(planet);
   }

   private int x;
   private int y;
   private int size;
}

